
XIncludeFile "Object.pb"


Structure StdString Extends Object
  string.s
EndStructure


;##############################################################################################################
;##### StdString #####

Procedure StdStringFree(*this.StdString)
  ClearStructure(*this, StdString)
  FreeMemory(*this)
EndProcedure


Declare NewStdString(string.s)

Procedure StdStringCopy(*this.StdString)
  ProcedureReturn NewStdString(*this\string)
EndProcedure


Procedure StdStringCompare(*this.StdString, *other.StdString)
  ProcedureReturn CompareMemoryString(@*this\string, @*other\string)
EndProcedure


Procedure.s StdStringToString(*this.StdString)
  ProcedureReturn *this\string
EndProcedure


Procedure NewStdString(string.s)
  Protected *this.StdString
  
  *this = AllocateMemory(SizeOf(StdString))
  InitializeStructure(*this, StdString)
  *this\free = @StdStringFree()
  *this\copy = @StdStringCopy()
  *this\compare = @StdStringCompare()
  *this\tostring = @StdStringToString()
  
  *this\string = string
  
  ProcedureReturn *this
EndProcedure


; IDE Options = PureBasic 4.51 (Windows - x86)