
%userdata *result.Integer


Global NewMap varValue.i()


%Structure 
  int.i
  str.s
%EndStructure


%token ASSIGN
%token.int NUMBER
%token.str VARIABLE

%left '+' '-'
%left '*' '/'
%right NEGATIVE

%type.int eval exp
%start eval

%%


exp: ;[
  NUMBER        {  = 1 }
  
  | VARIABLE {;[
    If FindMapElement(varValue(), 1)
       = varValue()
    Else
      yyerror("Cannot find the variable " + 1)
      ProcedureReturn 0
    EndIf
  };]
  
  | '(' exp ')' {  = 2 }
  | exp '+' exp {  = 1 + 3 }
  | exp '-' exp {  = 1 - 3 }
  | exp '*' exp {  = 1 * 3 }
  | exp '/' exp {  = 1 / 3 }
  | '-' exp %prec NEGATIVE {  = - 2 }
  
  | '(' exp error {;[
    yyerror("'(' without ')'")
    ProcedureReturn 0
  };]
;]

eval: ;[
  exp { *result\i = 1 }
  
  | VARIABLE ASSIGN exp {;[
    AddMapElement(varValue(), 1)
    varValue() = 3
    *result\i = 3
  };]
;]

%%


; IDE Options = PureBasic 4.60 (Windows - x86)
; EnableXP