
Enumeration 1
  #Error_SyntaxError
  
  #Error_NoParenthOpen
  #Error_NoParenthClose
  #Error_NoBracketOpen
  #Error_NoBracketClose
  #Error_NoCurlyOpen
  #Error_NoCurlyClose
  
  #Error_RangeOutOfOrdner
  #Error_GarbageEndLine
  #Error_CharacterLength
  
  #Error_DuplicateNonTerm
  #Error_DuplicateTermSym
  #Error_DuplicatePriority
  #Error_CantFindSymbol
  #Error_CantFindNonTerm
  #Error_CantFindStart
  #Error_WithoutStructure
  #Error_WithoutEndStruc
  #Error_CantUsedCollect
  #Error_RefInvalidChar
  #Error_RefIdxOutOfBounds
  #Error_RefNoDeclaredType
  
  #Error_ParameterOption
EndEnumeration

Global ErrorCode
Global Dim ErrorText.s(#PB_Compiler_EnumerationValue)
Global ErrorText1.s, ErrorText2.s, ErrorText3.s


ErrorText(#Error_SyntaxError)      = "Syntax error"

ErrorText(#Error_NoParenthOpen)     = "')' without '('"
ErrorText(#Error_NoParenthClose)    = "'(' without ')'"
ErrorText(#Error_NoBracketOpen)     = "']' without '['"
ErrorText(#Error_NoBracketClose)    = "'[' without ']'"
ErrorText(#Error_NoCurlyOpen)       = "'}' without '{'"
ErrorText(#Error_NoCurlyClose)      = "'{' without '}'"
ErrorText(#Error_RangeOutOfOrdner)  = "Range out of ordner"
ErrorText(#Error_GarbageEndLine)    = "Garbage at the end of the line"
ErrorText(#Error_CharacterLength)   = "Tokens between '' are limited to 1 character"
ErrorText(#Error_CantFindSymbol)    = "Can't find the symbol '%s1'"
ErrorText(#Error_CantFindNonTerm)   = "Can't find the non-terminal symbol '%s1'"
ErrorText(#Error_CantFindStart)     = "Can't find the start definition '%start'"
ErrorText(#Error_DuplicateNonTerm)  = "Duplicated not-terminal symbol: %s1"
ErrorText(#Error_DuplicateTermSym)  = "Duplicated terminal symbol: %s1"
ErrorText(#Error_DuplicatePriority) = "Duplicated definition of priority: %s1"
ErrorText(#Error_WithoutStructure)  = "'%EndStructure' without '%Structure'"
ErrorText(#Error_WithoutEndStruc)   = "'%Structure' without '%EndStructure'"
ErrorText(#Error_CantUsedCollect)   = "Can't used 'Array', 'List' or 'Map' in '%Structure'"
ErrorText(#Error_RefInvalidChar)    = "Invalid char behind '': '%s1'"
ErrorText(#Error_RefIdxOutOfBounds) = "Index out of bounds: '%s1'"
ErrorText(#Error_RefNoDeclaredType) = "'%s1' don't have a declared type"


Procedure.s GetErrorText()
  Protected text.s
  
  text = ErrorText(ErrorCode)
  text = ReplaceString(text, "%s1", ErrorText1)
  text = ReplaceString(text, "%s2", ErrorText2)
  text = ReplaceString(text, "%s3", ErrorText3)
  
  ProcedureReturn text
EndProcedure


; IDE Options = PureBasic 4.60 RC 2 (Windows - x86)
; EnableXP