
Global Param_InputFile.s
Global Param_OutputFile.s
Global Param_DotOutput.s
Global Param_PdfOutput.s
Global Param_DebugOutput.s


Procedure GetProgramParameter(title.s)
  Protected i, cnt, param.s
  
  cnt = CountProgramParameters()
  
  While (i < cnt)
    param = ProgramParameter(i)
    If (i = 0)
      Param_InputFile = param
    Else
      Select param
      Case "-o"
        i + 1
        Param_OutputFile = ProgramParameter(i)
        
      Case "-dot"
        i + 1
        Param_DotOutput = ProgramParameter(i)
        
      Case "-pdf"
        i + 1
        Param_PdfOutput = ProgramParameter(i)
        
      Case "-debug"
        i + 1
        Param_DebugOutput = ProgramParameter(i)
        
      Default
        MessageRequester(title, "Parameter error")
        End
      EndSelect
    EndIf
    i + 1
  Wend
  
  If (Param_InputFile = "")
    MessageRequester(title, "Parameter error")
    End
  EndIf
EndProcedure


; IDE Options = PureBasic 4.60 (Windows - x86)
; EnableXP