
Prototype __yylexerrun_proto(*userData)


CompilerIf (Defined(yyEOF, #PB_Constant) = 0)
  #yyEOF = 257
CompilerEndIf

CompilerIf (Defined(yyDebug, #PB_Constant) = 0)
  #yyDebug = #False
CompilerEndIf

CompilerIf (Defined(__yystructure, #PB_Structure) = 0)
  Structure __yystructure
    int.i
  EndStructure
CompilerEndIf


Structure __yylexerstate
  run.i
  Map go.i()
EndStructure


Global yytext.s
Global *yyin.Character

CompilerIf (Defined(yylval, #PB_Variable) = 0)
  Global yylval.__yystructure
CompilerEndIf

Macro __yylexer_charclass(_char_)
  PeekI(?__yylexer_charclass + _char_ * SizeOf(Integer))
EndMacro


Macro __yylexer_actiontable(_state_, _class_)
  PeekI(?__yylexer_actiontable + (_state_ * (cnt_charclass+1) + _class_) * SizeOf(Integer))
EndMacro

Macro __yylexer_run(_state_)
  PeekI(?__yylexer_actiontable + ((_state_+1) * (cnt_charclass+1) - 1) * SizeOf(Integer))
EndMacro


Procedure yyinput()
  Protected char
  
  char = *yyin\c
  If (char = 0)
    char = -1
  EndIf
  
  *yyin + SizeOf(Character)
  ProcedureReturn char
EndProcedure


Procedure yyunput()
  *yyin - SizeOf(Character)
EndProcedure


Procedure yylexer(*userData = #Null)
  Protected cur_state, char, class, action
  Protected i, debugText.s
  Protected cnt_charclass
  Protected newlineChar
  Protected protoret, proto.__yylexerrun_proto
  
  yytext = ""
  cur_state     = PeekI(?__yylexer_info + 0*SizeOf(Integer));startstate
  cnt_charclass = PeekI(?__yylexer_info + 1*SizeOf(Integer))
  
  char = yyinput()
  
  Repeat
    newlineChar = 0
    If (char = 10) Or (char = 13)
      newlineChar = char
    EndIf
    If (char >= 0) And (char <= 255)
      class = __yylexer_charclass(char)
      If (class <> 0)
        action = __yylexer_actiontable(cur_state, class)
        If (action > -1)
          yytext + Chr(char)
          cur_state = action
          
          char = yyinput()
          If (newlineChar > 0) And ((char = 10) Or (char = 13)) And (char <> newlineChar)
            yytext + Chr(char)
            char = yyinput()
          EndIf
          Continue
        EndIf
      EndIf
    ElseIf (char = -1)
      action = __yylexer_actiontable(cur_state, 0)
      If (action > -1)
        cur_state = action
      EndIf
    EndIf
    
    yyunput()
    
    proto = __yylexer_run(cur_state)
    If (proto <> #Null)
      protoret = proto(*userData)
      
      CompilerIf #yyDebug
        If (protoret >= #yyEOF)
          Restore __yyparser_tokenText
          For i = 0 To protoret - #yyEOF
            Read.s debugText
          Next
          Debug "yylexer("+Chr(34)+yytext+Chr(34)+", token="+debugText+")"
        Else
          Debug "yylexer("+Chr(34)+yytext+Chr(34)+", idx="+Str(protoret)+")"
        EndIf
      CompilerEndIf
;       If (protoret = 0)
;         End
;       EndIf
      ProcedureReturn protoret
    Else
      ProcedureReturn -1
    EndIf
  ForEver
EndProcedure


; IDE Options = PureBasic 4.60 (Windows - x86)
; EnableXP