
CompilerIf (Defined(yyEOF, #PB_Constant) = 0)
  #yyEOF = 257
CompilerEndIf

#__yyparserToken = #yyEOF

#__yyparserAccept = 1
#__yyparserShift  = $10000000
#__yyparserReduce = $20000000

CompilerIf (Defined(yyDebug, #PB_Constant) = 0)
  #yyDebug = #False
CompilerEndIf

CompilerIf (Defined(__yystructure, #PB_Structure) = 0)
  Structure __yystructure
    int.i
  EndStructure
CompilerEndIf

CompilerIf Defined(yyerror, #PB_Procedure) = #False
  Procedure yyerror(string.s)
    Debug "yyparser: "+string
  EndProcedure
CompilerEndIf

CompilerIf (Defined(yylval, #PB_Variable) = 0)
  Global yylval.__yystructure
CompilerEndIf

Prototype __yyparserrun_proto(*userData, Array values.__yystructure(1))


Macro __yyparser_actiontable(_state_, _token_)
  PeekI(?__yyparser_actiontable + (_state_ * cnt_token + _token_) * SizeOf(Integer))
EndMacro

Macro __yyparser_gototable(_state_, _nonterm_)
  PeekI(?__yyparser_gototable + (_state_ * cnt_nonterm + _nonterm_) * SizeOf(Integer))
EndMacro

Macro __yyparser_ruletable(_rule_, _idx_)
  PeekI(?__yyparser_ruletable + (_rule_*4 + _idx_) * SizeOf(Integer))
EndMacro

Macro __yyparser_chartotoken(_char_)
  PeekI(?__yyparser_chartotoken + (_char_) * SizeOf(Integer))
EndMacro


Macro __yyparser_error()
  While (ListSize(state_stack()) > 0)
    action = __yyparser_gototable(cur_state, err_token)
    
    If (action & #__yyparserShift)
      cur_state = action - #__yyparserShift
      __yyparser_shift(yylval)
      err_mode = #True
      Break
    Else
      If (ListSize(value_stack()) = 0)
        yyerror("Syntax error")
        ProcedureReturn 0
      EndIf
      DeleteElement(value_stack())
      DeleteElement(state_stack())
      cur_state = state_stack()
    EndIf
  Wend
EndMacro

Macro __yyparser_shift(_value_)
  CompilerIf #yyDebug
    Debug "yyparser(shift, "+Str(cur_state)+")"
  CompilerEndIf
  AddElement(value_stack())
  value_stack() = _value_
  AddElement(state_stack())
  state_stack() = cur_state
EndMacro


Procedure yyparser(*userData = #Null)
  Protected cur_state, token, action
  Protected err_token, err_mode
  Protected cnt_nonterm, cnt_token
  Protected rule, nonterm, count, nodel
  Protected NewList state_stack.i()
  Protected NewList value_stack.__yystructure()
  Protected protoret, proto.__yyparserrun_proto
  
  cur_state   = PeekI(?__yyparser_info + 0*SizeOf(Integer));startstate
  err_token   = PeekI(?__yyparser_info + 1*SizeOf(Integer));errortoken
  cnt_nonterm = PeekI(?__yyparser_info + 2*SizeOf(Integer))
  cnt_token   = PeekI(?__yyparser_info + 3*SizeOf(Integer))
  
  AddElement(state_stack())
  state_stack() = cur_state
  CompilerIf #yyDebug
    Debug "yyparser(start, "+Str(cur_state)+")"
  CompilerEndIf
  
  Repeat
    token = yylexer(*userData)
;     Debug "TOKEN: "+Str(token)
;     Debug yytext
;     Debug cur_state
    If (token > 0) And (token < 256)
      token = __yyparser_chartotoken(token)
      If (token = 0)
        token = #PB_Default ;Error
      EndIf
    EndIf
    
    If (token = 0)
      Break
    ElseIf (token = -1) ; ignore token
      
    ElseIf (token >= #__yyparserToken) And (token < #__yyparserToken + cnt_token)
      Repeat
        action = __yyparser_actiontable(cur_state, token-#__yyparserToken)
        If (action = 0)
          If (err_mode = #True)
            Break
          Else
            __yyparser_error()
          EndIf
          
        ElseIf (action = #__yyparserAccept)
          err_mode = #False
          ProcedureReturn #True
          
        ElseIf (action & #__yyparserShift)
          cur_state = action - #__yyparserShift
          __yyparser_shift(yylval)
          If (err_mode = #True)
            err_mode = #False
          Else
            Break
          EndIf
          
        ElseIf (action & #__yyparserReduce)
          err_mode = #False
          rule = action - #__yyparserReduce
          count   = __yyparser_ruletable(rule, 0)
          nodel   = __yyparser_ruletable(rule, 1)
          nonterm = __yyparser_ruletable(rule, 2)
          proto   = __yyparser_ruletable(rule, 3)
          
          Dim values.__yystructure(count)
          While (count > 0)
            values(count) = value_stack()
            If (nodel = #False)
              DeleteElement(value_stack())
              DeleteElement(state_stack())
            Else
              PreviousElement(value_stack())
            EndIf
            count - 1
          Wend
          LastElement(value_stack())
          
          If (proto <> #Null)
            protoret = proto(*userData, values())
          Else
            protoret = #True
          EndIf
          If (protoret = #False)
            ProcedureReturn #False
          EndIf
          
          cur_state = state_stack()
          action = __yyparser_gototable(cur_state, nonterm)
          
          CompilerIf #yyDebug
            Debug "yyparser(reduce, "+Str(cur_state)+")"
          CompilerEndIf
          
          If (action & #__yyparserShift)
            cur_state = action - #__yyparserShift
            __yyparser_shift(values(0))
          Else
            __yyparser_error()
          EndIf
          
        EndIf
      ForEver
    Else
      __yyparser_error()
    EndIf
    
  ForEver
EndProcedure


; IDE Options = PureBasic 4.60 (Windows - x86)
; EnableXP